/**
 * 
 */
package com.icauda.article.pgm.tri.algo;

import static com.icauda.article.pgm.tri.util.Elements.permuter;

import java.util.Arrays;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author thierry.leriche
 * 
 */
public class DemiBulleTri implements Tri {

	private static final Logger logger = LoggerFactory.getLogger(DemiBulleTri.class);

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.icauda.article.pgm.tri.algo.Tri#trier(int[])
	 */
	@Override
	public int[] trierCopy(int[] tab) {

		final int[] result = Arrays.copyOf(tab, tab.length);

		trier(result);

		return result;

	}

	@Override
	public void trier(final int[] tab) {
		int nb = 0;
		int nbPermutation = 0;

		for (int i = 0; i < tab.length - 1; i++) {
			for (int j = 1; j < tab.length - i; j++) {
				if (tab[j] < tab[j - 1]) {
					// Permutation
					permuter(j, j - 1, tab);

					nbPermutation++;
				}
				nb++;
			}
		}

		logger.debug("nb : {}", nb);
		logger.debug("nb permutation : {}", nbPermutation);
	}
}
