package com.icauda.article.pgm.tri.algo;

import java.util.Arrays;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.icauda.article.pgm.tri.util.Element;
import com.icauda.article.pgm.tri.util.Elements;

public class Insertion2Tri implements Tri {

	private static final Logger logger = LoggerFactory.getLogger(Insertion2Tri.class);

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.icauda.article.pgm.tri.algo.Tri#trier(int[])
	 */
	@Override
	public int[] trierCopy(int[] tab) {

		if (tab.length == 0) {
			final int[] result = {};
			return result;
		}

		if (tab.length == 1) {
			final int[] result = new int[1];
			result[0] = tab[0];
			return result;
		}

		int nbTest = 0;

		Element tete = new Element(tab[0]);

		for (int i = 1; i < tab.length; i++) {
			Element elt = new Element(tab[i]);

			Element next = tete;
			Element previous = null;

			while (next != null) {
				nbTest++;
				if (tab[i] < next.getValue()) {
					if (previous == null) {
						tete = elt;
					} else {
						previous.setNext(elt);
					}
					elt.setNext(next);
					break;
				}

				previous = next;
				next = next.getNext();

				if (next == null) {
					// arrive a la fin
					previous.setNext(elt);
				}
			}
		}

		logger.debug("nbTest : {}", nbTest);

		return Elements.toTab(tete);
	}

	@Override
	public void trier(final int[] tab) {

		if (tab.length < 2) {
			return;
		}

		int nbTest = 0;

		Element tete = new Element(tab[0]);

		for (int i = 1; i < tab.length; i++) {
			final Element elt = new Element(tab[i]);

			Element next = tete;
			Element previous = null;

			while (next != null) {
				nbTest++;
				if (tab[i] < next.getValue()) {
					if (previous == null) {
						tete = elt;
					} else {
						previous.setNext(elt);
					}
					elt.setNext(next);
					break;
				}

				previous = next;
				next = next.getNext();

				if (next == null) {
					// arrive a la fin
					previous.setNext(elt);
				}
			}
		}

		// Ici on peut se le permettre car on sait que le tableau et la liste font necessairement la meme taille.
		Element next = tete;
		for (int i = 0; i < tab.length; i++) {
			tab[i] = next.getValue();
			next = next.getNext();
		}
	}

}
