/**
 * 
 */
package com.icauda.article.pgm.tri.algo;

import java.util.LinkedList;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * TODO
 * 
 * @author Thierry Leriche-Dessirier (www.icauda.com)
 * 
 */
public class InterTri implements Tri {

	private static final Logger logger = LoggerFactory.getLogger(InterTri.class);

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.icauda.article.pgm.tri.algo.Tri#trier(int[])
	 */
	@Override
	public int[] trierCopy(int[] tab) {

		throw new UnsupportedOperationException("not yet");
	}

	@Override
	public void trier(final int[] tab) {
		if (tab == null || tab.length < 2) {
			return;
		}

		final int size = tab.length;

		final int[] tabA = new int[size];
		final int[] tabB = new int[size];

		while (true) {

			int a = 0;
			int b = 0;
			int previous = Integer.MIN_VALUE;

			// separation
			boolean toA = true;
			for (final int elt : tab) {
				if (elt < previous) {
					toA = !toA;
				}

				if (toA) {
					tabA[a++] = elt;
				} else {
					tabB[b++] = elt;
				}

				previous = elt;
			}

			if (b == 0) {
				return;
			}

			// Fusion
			int a2 = 0;
			int b2 = 0;
			int i = 0;
			while (a2 < a || b2 < b) {
				if (a <= a2) {
					while (b2 < b) {
						tab[i++] = tabB[b2++];
					}
				} else if (b <= b2) {
					while (a2 < a) {
						tab[i++] = tabA[a2++];
					}
				} else {
					if (tabA[a2] < tabB[b2]) {
						tab[i++] = tabA[a2++];
					} else {
						tab[i++] = tabB[b2++];
					}
				}
			}

		}

	}

	public void trier_old(final int[] tab) {

		if (tab == null || tab.length < 2) {
			return;
		}

		final int size = tab.length;

		final int[] ab = new int[size];

		while (true) {

			int a = 0;
			int b = size - 1;

			// Separation dans ab-a et ab-b
			int previous = Integer.MIN_VALUE;
			for (final int elt : tab) {
				if (previous <= elt) {
					ab[a++] = elt;
				} else {
					ab[b--] = elt;
				}

				previous = elt;
			}

			// Tout a ete mis dans ab-a
			if (b == size - 1) {
				break;
			}
			System.out.println("ici");
			// Fusion
			a--;
			b++;
			int i = 0;
			int a2 = 0;
			while (a2 <= a || b < size) {
				if (a2 < a) {
					// Recopie a l'envers
					for (int j = size - 1; i <= j; j--) {
						tab[i++] = ab[j];
					}
					break;
				} else if (size <= b) {
					// System.arraycopy(ab, a2, tab, i, size - i);
					for (int j = a2; j <= a; j++) {
						tab[i++] = ab[j];
					}
					break;
				} else {
					if (ab[a2] < ab[b]) {
						tab[i] = ab[a2++];
					} else {
						tab[i] = ab[b++];
					}
				}
			}
		}

		// System.arraycopy(tab2, 0, tab, 0, tab.length);

	}

}
