/**
 * 
 */
package com.icauda.article.pgm.tri.algo;

import static com.icauda.article.pgm.tri.util.Elements.permuter;

import java.util.Arrays;
import java.util.LinkedList;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.google.common.collect.Lists;

/**
 * TODO
 * 
 * @author Thierry Leriche-Dessirier (www.icauda.com)
 * 
 */
public class InterViaListe2Tri implements Tri {

	private static final Logger logger = LoggerFactory.getLogger(InterViaListe2Tri.class);

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.icauda.article.pgm.tri.algo.Tri#trier(int[])
	 */
	@Override
	public int[] trierCopy(int[] tab) {

		throw new UnsupportedOperationException("not yet");
	}

	@Override
	public void trier(final int[] tab) {

		if (tab == null || tab.length < 2) {
			return;
		}

		final LinkedList<Integer> liste = new LinkedList<>();
		for (final int elt : tab) {
			liste.add(elt);
		}

		final LinkedList<Integer> listeTriee = trier(liste);
		int i = 0;
		for (final int elt : listeTriee) {
			tab[i++] = elt;
		}
	}

	private LinkedList<Integer> trier(final LinkedList<Integer> liste) {

		final LinkedList<Integer> a = new LinkedList<>();
		final LinkedList<Integer> b = new LinkedList<>();

		while (true) {
			Integer previous = Integer.MIN_VALUE;
			boolean isB = false;

			// Separation
			while (!liste.isEmpty()) {
				final Integer elt = liste.removeFirst();

				if (!isB && elt.compareTo(previous) < 0) {
					isB = !isB;
				}

				if (!isB) {
					a.add(elt);
				} else {
					b.add(elt);
				}

				previous = elt;
			}

			if (b.isEmpty()) {
				return a;
			}

			// Fusion
			while (!a.isEmpty() || !b.isEmpty()) {
				if (a.isEmpty()) {
					liste.addAll(b);
					b.clear();
				} else if (b.isEmpty()) {
					liste.addAll(a);
					a.clear();
				} else {
					final Integer eltA = a.getFirst();
					final Integer eltB = b.getFirst();

					if (eltA.compareTo(eltB) < 0) {
						liste.add(eltA);
						a.removeFirst();
					} else {
						liste.add(eltB);
						b.removeFirst();
					}
				}
			}
		}
	}
}
