package com.icauda.article.pgm.tri.algo;

import static com.icauda.article.pgm.tri.util.Elements.decaler;
import static com.icauda.article.pgm.tri.util.Elements.permuter;

import java.util.Arrays;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class RapideCopyJdkTri implements Tri {

	private static final Logger logger = LoggerFactory.getLogger(RapideCopyJdkTri.class);

	@Override
	public int[] trierCopy(int[] tab) {

		final int[] result = Arrays.copyOf(tab, tab.length);

		trier(result);

		return result;
	}

	@Override
	public void trier(final int[] tab) {
		if (tab.length == 0) {
			return;
		}
		trier(tab, 0, tab.length);
	}

	private static void trier(final int tab[], final int gauche, final int taille) {

		final int pivot = tab[gauche];

		// Establish Invariant: v* (<v)* (>v)* v*
		int g = gauche;
		int g2 = g;
		int d = gauche + taille - 1;
		int d2 = d;
		while (true) {
			while (g2 <= d && tab[g2] <= pivot) {
				if (tab[g2] == pivot) {
					permuter(g++, g2, tab);
				}
				g2++;
			}
			while (d >= g2 && pivot <= tab[d]) {
				if (tab[d] == pivot) {
					permuter(d, d2--, tab);
				}
				d--;
			}
			if (g2 > d) {
				break;
			}
			permuter(g2++, d--, tab);
		}

		// Swap partition elements back to middle
		int s, n = gauche + taille;
		s = Math.min(g - gauche, g2 - g);
		decaler(tab, gauche, g2 - s, s);
		s = Math.min(d2 - d, n - d2 - 1);
		decaler(tab, g2, n - s, s);

		// Recursively sort non-partition-elements
		if (1 < (s = g2 - g)) {
			trier(tab, gauche, s);
		}
		if (1 < (s = d2 - d)) {
			trier(tab, n - s, s);
		}
	}

	

}
