package com.icauda.article.pgm.tri.algo;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.icauda.article.pgm.tri.util.Elements;

public class RapideViaListe2Tri implements Tri {

	private static final Logger logger = LoggerFactory.getLogger(RapideViaListe2Tri.class);

	@Override
	public int[] trierCopy(int[] tab) {

		final int[] result = Arrays.copyOf(tab, tab.length);

		trier(result);

		return result;
	}

	@Override
	public void trier(final int[] tab) {

		final List<Integer> liste = Elements.tabToList(tab);

		final List<Integer> result = trier(liste);

		Elements.ecraser(result, tab);

	}

	private List<Integer> trier(final List<Integer> liste) {

		if (liste == null || liste.isEmpty()) {
			return new ArrayList<>();
		}

		// Choix du pivot a gauche
		final Integer pivot = liste.get(0);

		final List<Integer> listeGauche = new ArrayList<>();
		final List<Integer> listeCentre = new ArrayList<>();
		final List<Integer> listeDroite = new ArrayList<>();

		// Separation en deux sous listes
		for (final Integer elt : liste) {
			final int comp = elt.compareTo(pivot);
			if (comp < 0) {
				listeGauche.add(elt);
			} else if (comp == 0) {
				listeCentre.add(elt);
			} else {
				listeDroite.add(elt);
			}
		}

		liste.clear();

		liste.addAll(trier(listeGauche));
		liste.addAll(listeCentre);
		liste.addAll(trier(listeDroite));

		return liste;
	}

	

}
