package com.icauda.article.pgm.tri.algo;

import java.util.Arrays;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class SelectionTri implements Tri {

	private static final Logger logger = LoggerFactory.getLogger(SelectionTri.class);

	@Override
	public int[] trierCopy(int[] tab) {

		final int[] result = Arrays.copyOf(tab, tab.length);

		trier(result);

		return result;
	}

	@Override
	public void trier(final int[] tab) {
		long nb = 0;
		long nbPermutation = 0;

		for (int i = 0; i < tab.length; i++) {

			// Chercher la position (pos) du plus petit dans la zone restante i a fin
			int pos = i;
			for (int j = i; j < tab.length; j++) {
				if (tab[j] < tab[pos]) {
					pos = j;
				}
				nb++;
			}
			final int petit = tab[pos];

			// Delaler de i a pos
			for (int j = pos; i < j; j--) {
				tab[j] = tab[j - 1];
				nbPermutation++;
			}

			// mettre le plus petit trouve a la fin de l
			tab[i] = petit;
		}

		logger.debug("nb : {}", nb);
		logger.debug("nbPermutation : {}", nbPermutation);
	}

}
